
CoCoALib - Bug #1719

FactorINT has got worse

18 Dec 2022 22:21 - John Abbott

Status: Closed Start date: 18 Dec 2022

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Improving Estimated time: 4.25 hours

Target version: CoCoALib-0.99880 Spent time: 4.25 hours

Description

The following test case now works definitely worse: it does not find all factors even with a time limit of 500s

/**/ N := 7335701525182455855723732507566255591134481346601986023037611611157687476400397907172094

17626237639378612023600490998560722366656257767282271308180638747136088764270749773654824484097677

30935126492831066761899696701907156056883150559129963966735932455182327638929721004008567168335684

23192683967985101287078399186607316517429449761826354836313848479794861073944468980181075110165609

10005596514601338985074510750215438930245087413050220796147701159726256814712012430345949169082884

99088287453082756692594613080441807599303963687587136059239274906772988637774145815785013412195056

79095499167265653978483500586865402140691057641887605844688533833498927399511031246133015803817507

25368069448730717900262503172080923537952743527354828006932763006833830058133849992482291591524548

61401395052596021498767869726897693710222989619659223570001810463546688042778334712178574598468452

33580751730764998271802796529492735736983437115298752298259908753654837027508856708592906495842918

83576700534135208017967703488280321905547261081835293870066770359958302581979227942835018238328109

58492453928967775470538568305023369776559928320816622874487759999788504472705489498939725019786406

0072413943048908893072281613818181255952564156500184276607648975880782796071856116659;

/**/ facs := FactorINT_TimeOut(N,150);

/**/ len(facs.factors);

--> 164 or 146??

/**/ TimeFrom(0);

--> 203.014

/**/ indent(facs);

 

Fix it!

Related issues:

Related to CoCoA-5 - Feature #1718: FactorINT with time-out Closed 16 Dec 2022

History

#1 - 18 Dec 2022 22:24 - John Abbott

With the current impl on 127 factors are found, and they are all small enough to be split easily.

So why weren't they split?

I guess there should be a priority of composites still to factorize, and the remaining time should

"shared" among them (somehow).  The current recursive approach could soak up all the time just

trying to spit one factor [which has supposedly been checked to be non prime]

Too late/tired to investigate now.

#2 - 18 Dec 2022 22:24 - John Abbott

- Related to Feature #1718: FactorINT with time-out added
#3 - 22 Dec 2022 11:18 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

I now have a simpler case:

N:=24779178594458173980130149093512103993457937724258608763291319648856569108694977170434160467895396564484861

32552060029046961322718232452442973411060551404265714369418047516216332372133665902078765565144695299617386420

03205240903166519898987791573464612160928820311447243577699504315279381041379805020577653410356076373452127317

54271287261785041678993568253460048661063847966810757572974085958913630282096094357234844078158327390487652060

54617458349582046988466791681053269676155963371738838977255009823666709049453364472361394843359092246259752100

06424970052329750496284041467999849356023268907689315561144393069893490828305045902428170300866707044870638391

726523593031045407984564584577896295982661600067137457974854069039430186771628107;

 

It seems that FactorINT is unable to factorize it, but FactorINT_PollardRho(N,1000000) finds a factor instantly.

I wonder what is going on.

#4 - 29 Dec 2022 20:57 - John Abbott

- Assignee set to John Abbott

- % Done changed from 10 to 50

It'd be nice to blame someone else for the "poorly organized" code...

Now it seems to work better.  But the revised code still need tidying!

Maybe I'll check in soon what I have... and tidy it later (hah!)

#5 - 29 Dec 2022 21:16 - John Abbott

On some inputs which have many small factors, the code spends much more time inside IsProbPrime than actually computing factors.

Need a strategy to test for primality not too often...

#6 - 09 Mar 2023 22:37 - John Abbott

- Status changed from In Progress to Feedback

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99880

- % Done changed from 50 to 90

The current code works a lot better.

I suppose I should find time sooner or later to implement the idea in comment 5 (but that is low priority for CoCoALib).

#7 - 22 Apr 2024 20:00 - John Abbott
- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 4.25 h

The current impl is good enough.  It behaves well enough on the two "big" test examples listed above.  If we really want to offer good integer

factorization, we should use an external library.  But we should do that only if there is genuine demand... there are other more pressing issues!

Closing!
